//+------------------------------------------------------------------+
//|                                                      jbtest3.mq4 |
//|                                    Copyright  2009, Johan Brits |
//|                                       http://www.besharewise.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Johan Brits"
#property link      "http://www.besharewise.com"

#define MAGICMA  20090101

extern double Lots               = 0.01;
extern double MaximumRisk        = 0.02;

extern int TakeProfit = 800;
extern int StopLoss = 200;
extern int TrailingStop=400;
extern int TS.Min.Move.Pips = 1;

extern int Slippage = 5;

extern int StartHour = 0;  // No significant gain here at present
extern int EndHour   = 24; // No significant gain here at present

extern double DecreaseFactor = 3;
extern double ShortEma       = 21; // Best on Alpari Live data - originally 23
extern double LongEma        = 40; // Best on Alpari Live data - originally 38

extern int MAMode = 1; // 0=SMA 1=EMA 2=Smoothed 3=Linear Weighted - EMA rules (usually) on Cable

string strComment = "jbtest3 1.01 GBPUSD H1";
int iPeriod;
string strSymbol;

int Real.TakeProfit, Real.StopLoss, Real.Slippage, Real.TrailingStop, Real.TS.Min.Move.Pips;

/*
1.01
Added Trailing Stop
Added Trading Hours
Added MA Mode 


38	607.25	45	2.93	13.49	 96.62	15.31%	ShortEma=21 	LongEma=40	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3

32	541.35	37	3.36	14.63	 98.12	16.40%	ShortEma=25 	LongEma=38	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3

41	792.42	65	2.31	12.19	237.14	39.52%	ShortEma=11 	LongEma=42	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3
33	772.75	75	2.00	10.30	237.14	39.47%	ShortEma=11 	LongEma=40	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3
26	720.86	59	2.23	12.22	239.54	39.59%	ShortEma=13 	LongEma=38	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3
8	670.49	53	2.45	12.65	208.84	25.17%	ShortEma=25 	LongEma=32	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3
27	646.35	57	2.02	11.34	239.54	40.03%	ShortEma=15 	LongEma=38	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3
9	639.80	85	1.55	7.53	237.94	40.46%	ShortEma=11 	LongEma=34	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3
34	637.85	57	2.00	11.19	239.54	40.15%	ShortEma=13 	LongEma=40	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=300 	StopLoss=200 	Slippage=5 	DecreaseFactor=3



102	1241.74	45	4.57	27.59	128.41	17.12%	TakeProfit=800 	StopLoss=200 	TrailingStop=400	Lots=0.01 	MaximumRisk=0.02 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40 	MAMode=1
134	1230.23	45	4.54	27.34	129.80	17.12%	TakeProfit=800 	StopLoss=200 	TrailingStop=500	Lots=0.01 	MaximumRisk=0.02 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40 	MAMode=1
110	1168.48	45	4.26	25.97	142.74	16.92%	TakeProfit=800 	StopLoss=300 	TrailingStop=400	Lots=0.01 	MaximumRisk=0.02 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40 	MAMode=1

 73	596.24	45	2.83	13.25	100.28	11.52%	TakeProfit=300 	StopLoss=300 	TrailingStop=300	Lots=0.01 	MaximumRisk=0.02 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40 	MAMode=1
105	596.24	45	2.83	13.25	100.28	11.52%	TakeProfit=300 	StopLoss=300 	TrailingStop=400	Lots=0.01 	MaximumRisk=0.02 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40 	MAMode=1
137	596.24	45	2.83	13.25	100.28	11.52%	TakeProfit=300 	StopLoss=300 	TrailingStop=500	Lots=0.01 	MaximumRisk=0.02 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40 	MAMode=1

2	1241.74	45	4.57	27.59	128.41	17.12%	MAMode=1	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=800 	StopLoss=200 	TrailingStop=400 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40
4	820.93	73	2.07	11.25	235.43	27.22%	MAMode=3	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=800 	StopLoss=200 	TrailingStop=400 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40
1	655.26	73	1.66	8.98	407.80	28.05%	MAMode=0	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=800 	StopLoss=200 	TrailingStop=400 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40
3	243.35	27	1.55	9.01	216.57	29.23%	MAMode=2	Lots=0.01 	MaximumRisk=0.02 	TakeProfit=800 	StopLoss=200 	TrailingStop=400 	TS.Min.Move.Pips=1 	Slippage=5 	StartHour=0 	EndHour=24 	DecreaseFactor=3 	ShortEma=21 	LongEma=40


*/

//+------------------------------------------------------------------+
//| Supporting functions                                             |
//+------------------------------------------------------------------+

void MoveTSPerMNwithFullPip(int iMN, int iTS)
{
// Changed to not default a SL

int icnt, itotal;
double dTS, dMinMove, dActualMove;

dMinMove = (Point*iTS)+(Real.TS.Min.Move.Pips*Point);
dActualMove = (Point*iTS);

itotal=OrdersTotal();

   for(icnt=0;icnt<itotal;icnt++) 
     {                               // order loop boundary
      OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
      
       // check for opened position, symbol & MagicNumber
      if(OrderType()==OP_SELL && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)  
        {     
         if((OrderOpenPrice() - Ask) > (dActualMove))
          {         
           if((OrderStopLoss() - Ask) > dMinMove)  
              {
                dTS = NormalizeDouble(Ask+dActualMove, Digits);
                OrderModify(OrderTicket(),OrderOpenPrice(), dTS, OrderTakeProfit(),0,Yellow);
              }
          }
      }
        
        
       if(OrderType()==OP_BUY && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)  
        {   
         if((Bid - OrderOpenPrice()) > dActualMove)
          {     
            if((Bid - OrderStopLoss()) > dMinMove)
              {
                dTS = NormalizeDouble(Bid-dActualMove, Digits);
                OrderModify(OrderTicket(),OrderOpenPrice(), dTS,OrderTakeProfit(),0,Green);
              }
          }
              
        }

     }  // order loop boundary

return(0);
     
}


//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==strSymbol && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   //lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=strSymbol || OrderType()>OP_SELL || OrderMagicNumber() != MAGICMA) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1)  lot=NormalizeDouble(lot*losses,2);//lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   lot = MathMax(lot, MarketInfo(strSymbol, MODE_MINLOT));
   
   return(lot);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double Ema;
   int    res;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   Ema=iMA(NULL,0,ShortEma,LongEma,MAMode,PRICE_CLOSE,0);
   double SEMA1=iMA(NULL,0,ShortEma,0,MAMode,PRICE_CLOSE,1);
   double LEMA1=iMA(NULL,0,LongEma,0,MAMode,PRICE_CLOSE,1);
   double SEMA2=iMA(NULL,0,ShortEma,0,MAMode,PRICE_CLOSE,2);
   double LEMA2=iMA(NULL,0,LongEma,0,MAMode,PRICE_CLOSE,2);

//---- sell conditions
  // if(Open[1]>Ema && Close[1]<Ema)  
   if (SEMA1<LEMA1 && SEMA2>LEMA2) 
     {
      res=OrderSend(strSymbol,OP_SELL,LotsOptimized(),Bid,Real.Slippage,Bid+Real.StopLoss*Point,Bid-Real.TakeProfit*Point,strComment,MAGICMA,0,Red);
      return;
     }
//---- buy conditions
  // if(Open[1]<Ema && Close[1]>Ema)  
    if (SEMA1>LEMA1 && SEMA2<LEMA2) 
     {
      res=OrderSend(strSymbol,OP_BUY,LotsOptimized(),Ask,Real.Slippage,Ask-Real.StopLoss*Point,Ask+Real.TakeProfit*Point,strComment,MAGICMA,0,Blue);
      return;
     }
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double Ema;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   Ema=iMA(NULL,0,ShortEma,LongEma,MAMode,PRICE_CLOSE,0);
   double SEMA1=iMA(NULL,0,ShortEma,0,MAMode,PRICE_CLOSE,1);
   double LEMA1=iMA(NULL,0,LongEma,0,MAMode,PRICE_CLOSE,1);
   double SEMA2=iMA(NULL,0,ShortEma,0,MAMode,PRICE_CLOSE,2);
   double LEMA2=iMA(NULL,0,LongEma,0,MAMode,PRICE_CLOSE,2);
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=strSymbol) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
        // if(Open[1]>Ema && Close[1]<Ema)
         if (SEMA1<LEMA1 && SEMA2>LEMA2)  OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
        }
      if(OrderType()==OP_SELL)
        {
        // if(Open[1]<Ema && Close[1]>Ema)
        if (SEMA1>LEMA1 && SEMA2<LEMA2)  OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   //if(CalculateCurrentOrders(strSymbol)==0) CheckForOpen();
  // else                                    CheckForClose();
  
   iPeriod = Period();
   strSymbol = Symbol();
   
   
    if(StringFind(strSymbol, "GBPUSD", 0)<0)
     {
      Print("Symbol set to: ", Symbol(), " is not correct for this EA!");
      Alert("Symbol set to: ", Symbol(), " is not correct for this EA!");
      return(3);  
     }
     
    if(iPeriod != PERIOD_H1) // Period of the chart should be same as signal period
     {
      Print("Period set to: ", iPeriod, " is not correct for this EA!");
      Alert("Period set to: ", iPeriod, " is not correct for this EA!");
      return(1);  
     }
     
     
  // Handle full/sub-pip 
   if (Digits == 4) 
     {
       Real.Slippage = Slippage;
       Real.TakeProfit = TakeProfit;
       Real.StopLoss = StopLoss;
       Real.TrailingStop = TrailingStop;
       Real.TS.Min.Move.Pips = TS.Min.Move.Pips;
     }
  
   if (Digits == 5) 
     {
       Real.Slippage = Slippage*10;
       Real.TakeProfit = TakeProfit*10;
       Real.StopLoss = StopLoss*10;
       Real.TrailingStop = TrailingStop*10;
       Real.TS.Min.Move.Pips = TS.Min.Move.Pips*10;
     }
     
   // Call Trailing Stop check every tick
   if (TrailingStop!=0) MoveTSPerMNwithFullPip(MAGICMA, Real.TrailingStop); 
     
     
   CheckForClose();
   
   
   
   if (Hour() < StartHour || Hour() > EndHour) return (0);
   
   CheckForOpen();

//----
  }
//+------------------------------------------------------------------+